using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace UVAnimationTest3
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;


        // f̐錾
        private const int modelMax = 1500;

        // AjXVԊu̐錾i~bj
        private const int animeUpdateInterval = 80;

        // ̐錾
        public static Random random = new Random();


        // JX^_\̂̒`
        public struct VertexPositionTextureNormal
        {
            public Vector3 Position;
            public Vector2 TextureCoordinate;
            public Vector3 Normal;

            public VertexPositionTextureNormal(Vector3 position, Vector2 textureCoordinate, Vector3 normal)
            {
                this.Position = position;
                this.TextureCoordinate = textureCoordinate;
                this.Normal = normal;
            }

            public static readonly VertexElement[] VertexElements
                = {
                new VertexElement(
                    0,
                    0,
                    VertexElementFormat.Vector3,
                    VertexElementMethod.Default,
                    VertexElementUsage.Position,
                    0
                ),

                new VertexElement(
                    0,
                    sizeof(float) * 3,
                    VertexElementFormat.Vector2,
                    VertexElementMethod.Default,
                    VertexElementUsage.TextureCoordinate,
                    0
                ),

                new VertexElement(
                    0, 
                    sizeof(float) * (3 + 2),
                    VertexElementFormat.Vector3,
                    VertexElementMethod.Default,
                    VertexElementUsage.Normal,
                    0
                )
            };

            // JX^_tH[}bg̃TCY擾
            public static int SizeInBytes
            {
                get
                {
                    // return sizeof(float) * (3 + 2 + 3);
                    return System.Runtime.InteropServices.Marshal.SizeOf(typeof(VertexPositionTextureNormal));
                }
            }
        }

        // JX^_f[^̐錾
        private VertexPositionTextureNormal[] verData = new VertexPositionTextureNormal[4];

        // CfbNXf[^̐錾
        private Int16[] indexData = new Int16[6 * 2];   // ʔ|gpĂ̂łQ{

        // I_obt@̐錾
        private DynamicVertexBuffer[][] vertexBuffer = new DynamicVertexBuffer[modelMax][];

        // ICfbNXobt@̐錾
        private DynamicIndexBuffer[][] indexBuffer = new DynamicIndexBuffer[modelMax][];

        // f̐錾
        private Model[] myModel = new Model[modelMax];

        // eNX`̐錾
        private Texture2D myTexture;

        // fW̐錾
        private Vector3[] modelPos = new Vector3[modelMax];

        // \Ajԍ̐錾
        private int[] animeNo = new int[modelMax];

        // ^C}[̐錾
        private float[] timer = new float[modelMax];



        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            this.spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here

            // eNX`̌Ăяo
            this.myTexture = Content.Load<Texture2D>("SpearMan01Attack01");


            for (int i = 0; i < modelMax; i++)
            {
                // f̌Ăяo
                this.myModel[i] = Content.Load<Model>("MyModel");

                // fW_ɐݒ
                this.modelPos[i].X = (float)random.Next(300) - 150;
                this.modelPos[i].Y = (float)random.Next(300) - 150;
                this.modelPos[i].Z = (float)random.Next(300) - 150;

                // ^C}[̏l_ɐݒ
                this.timer[i] = (float)random.Next(10000);

                // \Ajԍ
                this.animeNo[i] = 0;


                // _obt@̐錾
                this.vertexBuffer[i] = new DynamicVertexBuffer[this.myModel[i].Meshes.Count];

                // CfbNXobt@̐錾
                this.indexBuffer[i] = new DynamicIndexBuffer[this.myModel[i].Meshes.Count];

                for (int j = 0; j < this.myModel[i].Meshes.Count; j++)
                {
                    // _obt@̏
                    this.vertexBuffer[i][j] = new DynamicVertexBuffer(
                        this.GraphicsDevice,
                        this.myModel[i].Meshes[j].VertexBuffer.SizeInBytes,
                        this.myModel[i].Meshes[j].VertexBuffer.BufferUsage);

                    // CfbNXobt@̏
                    this.indexBuffer[i][j] = new DynamicIndexBuffer(
                        this.GraphicsDevice,
                        this.myModel[i].Meshes[j].IndexBuffer.SizeInBytes,
                        this.myModel[i].Meshes[j].IndexBuffer.BufferUsage,
                        this.myModel[i].Meshes[j].IndexBuffer.IndexElementSize);

                    // _obt@ƃCfbNXobt@̃f[^XV
                    vertexAndIndexBufferUpdate(i, this.animeNo[i]);
                }
            }
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            // GraphicDeviceɒ_̌^ݒ肷
            this.graphics.GraphicsDevice.VertexDeclaration = new VertexDeclaration(
                this.GraphicsDevice,
                VertexPositionTextureNormal.VertexElements);

            // r[Wϊs
            Matrix view = Matrix.CreateLookAt(
                new Vector3(0, 0, 400),
                Vector3.Zero,
                Vector3.Up);

            // ˉeϊs
            Viewport viewport = graphics.GraphicsDevice.Viewport;
            float aspectRatio = (float)viewport.Width / (float)viewport.Height;
            Matrix projection = Matrix.CreatePerspectiveFieldOfView(
                MathHelper.PiOver4,
                aspectRatio,
                10, 1000);


            for (int i = 0; i < modelMax; i++)
            {
                // ^C}[̍XV
                this.timer[i] += (float)gameTime.ElapsedGameTime.TotalMilliseconds;

                // V\AjԍZo
                int newAnimeNo = (int)(this.timer[i] / animeUpdateInterval);
                if (newAnimeNo >= 32 * 19)
                {
                    newAnimeNo = 0;
                    this.timer[i] = 0;
                }

                // O̕\AjԍƐV\Ajԍr`FbN
                if (this.animeNo[i] != newAnimeNo)
                {
                    // \AjԍXV
                    this.animeNo[i] = newAnimeNo;

                    // _obt@ƃCfbNXobt@̃f[^XV
                    this.vertexAndIndexBufferUpdate(i, this.animeNo[i]);
                }


                // [hWϊs
                Matrix world = Matrix.CreateScale(20.0f) *
                    Matrix.CreateRotationX(this.timer[i] / 3000f) *
                    Matrix.CreateRotationY(this.timer[i] / 1000) *
                    Matrix.CreateTranslation(this.modelPos[i]);


                for (int j = 0; j < this.myModel[i].Meshes.Count; j++)
                {
                    // `Ɏgp钸_obt@Zbg
                    this.GraphicsDevice.Vertices[0].SetSource(
                        this.vertexBuffer[i][j],
                        0,
                        VertexPositionTextureNormal.SizeInBytes
                        );

                    // `ɎgpCfbNXobt@Zbg
                    this.GraphicsDevice.Indices = this.indexBuffer[i][j];


                    foreach (ModelMeshPart modelMeshPart in this.myModel[i].Meshes[j].MeshParts)
                    {
                        // GtFNg̐錾
                        Effect effect = modelMeshPart.Effect;

                        // [hAr[Aˉeϊs̐ݒ
                        effect.Parameters["World"].SetValue(world);
                        effect.Parameters["View"].SetValue(view);
                        effect.Parameters["Projection"].SetValue(projection);

                        // GtFNgJn
                        effect.Begin();

                        foreach (EffectPass pass in effect.CurrentTechnique.Passes)
                        {
                            // GtFNgpXJn
                            pass.Begin();

                            // CfbNXgp_`
                            this.graphics.GraphicsDevice.DrawIndexedPrimitives(
                                PrimitiveType.TriangleList,
                                modelMeshPart.BaseVertex,
                                0,
                                modelMeshPart.NumVertices,
                                modelMeshPart.StartIndex,
                                modelMeshPart.PrimitiveCount);

                            // GtFNgpXI
                            pass.End();
                        }

                        // GtFNgI
                        effect.End();
                    }
                }
            }

            base.Draw(gameTime);
        }


        // _obt@ƃCfbNXobt@̃f[^XV
        private void vertexAndIndexBufferUpdate(int modelNo, int animeNo)
        {
            // eNX`WZo
            int iWidth = 80;    // 摜P̉iintj
            int iHeight = 80;   // 摜P̏ciintj
            int animeWidthMax = 25;    // Aj摜̉
            float fWidth = (float)iWidth / (float)myTexture.Width;    // 摜P̉ifloatj
            float fHeight = (float)iHeight / (float)myTexture.Height; // 摜P̏cifloatj
            float tx1 = (animeNo % animeWidthMax) * fWidth;
            float ty1 = (animeNo / animeWidthMax) * fHeight;
            float tx2 = tx1 + fWidth;
            float ty2 = ty1 + fHeight;


            for (int i = 0; i < this.myModel[modelNo].Meshes.Count; i++)
            {
                // _obt@f[^̃Rs[擾
                this.myModel[modelNo].Meshes[i].VertexBuffer.GetData<VertexPositionTextureNormal>(verData);

                // CfbNXobt@f[^̃Rs[擾
                this.myModel[modelNo].Meshes[i].IndexBuffer.GetData<Int16>(indexData);

                if (verData == null)
                {
                    Console.WriteLine("VertexBuffer.GetData ̒l null łI");
                }
                else if (indexData == null)
                {
                    Console.WriteLine("IndexBuffer.GetData ̒l null łI");
                }
                else
                {
                    // eNX`WւiUVAj[Vj
                    verData[0].TextureCoordinate = new Vector2(tx1, ty1);
                    verData[1].TextureCoordinate = new Vector2(tx2, ty2);
                    verData[2].TextureCoordinate = new Vector2(tx1, ty2);
                    verData[3].TextureCoordinate = new Vector2(tx2, ty1);

                    // _obt@Ƀf[^Zbg
                    this.vertexBuffer[modelNo][i].SetData<VertexPositionTextureNormal>(
                        verData,
                        0,
                        verData.GetLength(0),
                        SetDataOptions.NoOverwrite);

                    // CfbNXobt@Ƀf[^Zbg
                    this.indexBuffer[modelNo][i].SetData<Int16>(
                        indexData,
                        0,
                        indexData.GetLength(0),
                        SetDataOptions.NoOverwrite);
                }
            }
        }
    }
}
